<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: flair::core::IODevice Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classflair_1_1core_1_1_i_o_device.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classflair_1_1core_1_1_i_o_device-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">flair::core::IODevice Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract class for input/ouput system.  
 <a href="classflair_1_1core_1_1_i_o_device.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_i_o_device_8h_source.html">IODevice.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for flair::core::IODevice:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classflair_1_1core_1_1_i_o_device.png" usemap="#flair::core::IODevice_map" alt=""/>
  <map id="flair::core::IODevice_map" name="flair::core::IODevice_map">
<area href="classflair_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. " alt="flair::core::Object" shape="rect" coords="0,0,236,24"/>
<area href="classflair_1_1actuator_1_1_bl_ctrl_v2__x4__speed.html" alt="flair::actuator::BlCtrlV2_x4_speed" shape="rect" coords="246,112,482,136"/>
<area href="classflair_1_1actuator_1_1_bldc.html" title="Base class for brushless motors drivers. " alt="flair::actuator::Bldc" shape="rect" coords="246,168,482,192"/>
<area href="classflair_1_1actuator_1_1_simu_bldc.html" title="Class for a simulation bldc. " alt="flair::actuator::SimuBldc" shape="rect" coords="246,224,482,248"/>
<area href="classflair_1_1filter_1_1_ahrs.html" title="Abstract class for AHRS. " alt="flair::filter::Ahrs" shape="rect" coords="246,280,482,304"/>
<area href="classflair_1_1filter_1_1_butterworth_low_pass.html" title="Class defining a Butterworth low pass filter. " alt="flair::filter::ButterworthLowPass" shape="rect" coords="246,336,482,360"/>
<area href="classflair_1_1filter_1_1_control_law.html" title="Base class for control law input must be created by reimplemented class. output is created by this cl..." alt="flair::filter::ControlLaw" shape="rect" coords="246,392,482,416"/>
<area href="classflair_1_1filter_1_1_euler_derivative.html" title="Class defining an euler derivative. " alt="flair::filter::EulerDerivative" shape="rect" coords="246,448,482,472"/>
<area href="classflair_1_1filter_1_1_joy_reference.html" title="Class creating references from a joystick. " alt="flair::filter::JoyReference" shape="rect" coords="246,504,482,528"/>
<area href="classflair_1_1filter_1_1_low_pass_filter.html" title="Class defining a first order low pass filter. " alt="flair::filter::LowPassFilter" shape="rect" coords="246,560,482,584"/>
<area href="classflair_1_1filter_1_1_trajectory_generator1_d.html" title="Class generating a trajectory in 1D. " alt="flair::filter::TrajectoryGenerator1D" shape="rect" coords="246,616,482,640"/>
<area href="classflair_1_1filter_1_1_trajectory_generator2_d_circle.html" title="Class generating a circle trajectory in 2D. " alt="flair::filter::TrajectoryGenerator2DCircle" shape="rect" coords="246,672,482,696"/>
<area href="classflair_1_1filter_1_1_uav_multiplex.html" title="Class defining uav multiplexing. " alt="flair::filter::UavMultiplex" shape="rect" coords="246,728,482,752"/>
<area href="classflair_1_1meta_1_1_meta_dual_shock3.html" title="Classe intégrant la manette MetaDualShock3. " alt="flair::meta::MetaDualShock3" shape="rect" coords="246,784,482,808"/>
<area href="classflair_1_1sensor_1_1_camera.html" title="Base class for Camera. " alt="flair::sensor::Camera" shape="rect" coords="246,840,482,864"/>
<area href="classflair_1_1sensor_1_1_host_eth_controller.html" title="Base Class for host side remote controls that talks to target side through ethernet connection..." alt="flair::sensor::HostEthController" shape="rect" coords="246,896,482,920"/>
<area href="classflair_1_1sensor_1_1_imu.html" title="Base class for Imu. " alt="flair::sensor::Imu" shape="rect" coords="246,952,482,976"/>
<area href="classflair_1_1sensor_1_1_laser_range_finder.html" title="Classe generique intégrant les telemetres laser. " alt="flair::sensor::LaserRangeFinder" shape="rect" coords="246,1008,482,1032"/>
<area href="classflair_1_1sensor_1_1_nmea_gps.html" title="Base class for GPS using NMEA sentances. " alt="flair::sensor::NmeaGps" shape="rect" coords="246,1064,482,1088"/>
<area href="classflair_1_1sensor_1_1_pressure_sensor.html" title="Base class for PressureSensor. " alt="flair::sensor::PressureSensor" shape="rect" coords="246,1120,482,1144"/>
<area href="classflair_1_1sensor_1_1_radio_receiver.html" title="Base class for radio receiver. " alt="flair::sensor::RadioReceiver" shape="rect" coords="246,1176,482,1200"/>
<area href="classflair_1_1sensor_1_1_simu_camera.html" title="Class for a simulation camera. " alt="flair::sensor::SimuCamera" shape="rect" coords="246,1232,482,1256"/>
<area href="classflair_1_1sensor_1_1_simu_gps.html" title="Class for a simulation GPS. " alt="flair::sensor::SimuGps" shape="rect" coords="246,1288,482,1312"/>
<area href="classflair_1_1sensor_1_1_simu_imu.html" title="Class for a simulation Imu. " alt="flair::sensor::SimuImu" shape="rect" coords="246,1344,482,1368"/>
<area href="classflair_1_1sensor_1_1_simu_laser.html" alt="flair::sensor::SimuLaser" shape="rect" coords="246,1400,482,1424"/>
<area href="classflair_1_1sensor_1_1_simu_pressure_sensor.html" title="Class for a simulation PressureSensor. " alt="flair::sensor::SimuPressureSensor" shape="rect" coords="246,1456,482,1480"/>
<area href="classflair_1_1sensor_1_1_simu_us.html" title="Class for a simulation UsRangeFinder. " alt="flair::sensor::SimuUs" shape="rect" coords="246,1512,482,1536"/>
<area href="classflair_1_1sensor_1_1_target_controller.html" title="Base Class for target side remote controls. " alt="flair::sensor::TargetController" shape="rect" coords="246,1568,482,1592"/>
<area href="classflair_1_1sensor_1_1_us_range_finder.html" title="Base class for UsRangeFinder. " alt="flair::sensor::UsRangeFinder" shape="rect" coords="246,1624,482,1648"/>
<area href="classflair_1_1sensor_1_1_vrpn_object.html" title="Class for VRPN object. The IODevice is created with the VrpnClient as parent. VrpnClient must be crea..." alt="flair::sensor::VrpnObject" shape="rect" coords="246,1680,482,1704"/>
<area href="classflair_1_1simulator_1_1_model.html" alt="flair::simulator::Model" shape="rect" coords="246,1736,482,1760"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a9693b497752b466891eaafeb34bec4d3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a9693b497752b466891eaafeb34bec4d3">IODevice</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent, std::string name)</td></tr>
<tr class="memdesc:a9693b497752b466891eaafeb34bec4d3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a9693b497752b466891eaafeb34bec4d3">More...</a><br /></td></tr>
<tr class="separator:a9693b497752b466891eaafeb34bec4d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05246988b486def40926d8491e1bcc5f"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a05246988b486def40926d8491e1bcc5f">~IODevice</a> ()</td></tr>
<tr class="memdesc:a05246988b486def40926d8491e1bcc5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a05246988b486def40926d8491e1bcc5f">More...</a><br /></td></tr>
<tr class="separator:a05246988b486def40926d8491e1bcc5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7b42de6bb3893df860063228b55c229"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#af7b42de6bb3893df860063228b55c229">AddDeviceToLog</a> (const <a class="el" href="classflair_1_1core_1_1_i_o_device.html">IODevice</a> *device)</td></tr>
<tr class="memdesc:af7b42de6bb3893df860063228b55c229"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> to the logs.  <a href="#af7b42de6bb3893df860063228b55c229">More...</a><br /></td></tr>
<tr class="separator:af7b42de6bb3893df860063228b55c229"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e0b7af75abdbf39843d8bf2e45f08b9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a2e0b7af75abdbf39843d8bf2e45f08b9">AddDataToLog</a> (const <a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *data)</td></tr>
<tr class="memdesc:a2e0b7af75abdbf39843d8bf2e45f08b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an <a class="el" href="classflair_1_1core_1_1io__data.html" title="Abstract class for data types. ">io_data</a> to the log.  <a href="#a2e0b7af75abdbf39843d8bf2e45f08b9">More...</a><br /></td></tr>
<tr class="separator:a2e0b7af75abdbf39843d8bf2e45f08b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12d811c6926fb86da6b47f889109da66"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a12d811c6926fb86da6b47f889109da66">OutputToShMem</a> (bool enabled)</td></tr>
<tr class="memdesc:a12d811c6926fb86da6b47f889109da66"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send the output to a shared memory.  <a href="#a12d811c6926fb86da6b47f889109da66">More...</a><br /></td></tr>
<tr class="separator:a12d811c6926fb86da6b47f889109da66"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee7828ae2eece2bace8e476dacc2bc12"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#aee7828ae2eece2bace8e476dacc2bc12">IsReady</a> (void) const </td></tr>
<tr class="memdesc:aee7828ae2eece2bace8e476dacc2bc12"><td class="mdescLeft">&#160;</td><td class="mdescRight">is device ready  <a href="#aee7828ae2eece2bace8e476dacc2bc12">More...</a><br /></td></tr>
<tr class="separator:aee7828ae2eece2bace8e476dacc2bc12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75e82ca2ae2fb7c39d973dd3d16bc698"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a75e82ca2ae2fb7c39d973dd3d16bc698"></a>
virtual <a class="el" href="classflair_1_1core_1_1_data_type.html">DataType</a> const &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetInputDataType</b> () const </td></tr>
<tr class="separator:a75e82ca2ae2fb7c39d973dd3d16bc698"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa325be57d48b268006120dde75dd65cc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa325be57d48b268006120dde75dd65cc"></a>
virtual <a class="el" href="classflair_1_1core_1_1_data_type.html">DataType</a> const &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetOutputDataType</b> () const </td></tr>
<tr class="separator:aa325be57d48b268006120dde75dd65cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aec92383fd5bf68d9df10414862b7e95c">Object</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent=NULL, std::string name=&quot;&quot;, std::string type=&quot;&quot;)</td></tr>
<tr class="memdesc:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aec92383fd5bf68d9df10414862b7e95c">More...</a><br /></td></tr>
<tr class="separator:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aa2bde0e6677bbef705c96c93cb06ad09">~Object</a> ()</td></tr>
<tr class="memdesc:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#aa2bde0e6677bbef705c96c93cb06ad09">More...</a><br /></td></tr>
<tr class="separator:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a9b0344dff7e1c05424d9152c8274523a">ObjectName</a> (void) const </td></tr>
<tr class="memdesc:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name.  <a href="#a9b0344dff7e1c05424d9152c8274523a">More...</a><br /></td></tr>
<tr class="separator:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53">ObjectType</a> (void) const </td></tr>
<tr class="memdesc:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type.  <a href="#a609a250ec037fbcaf8957c8f1dcbfc53">More...</a><br /></td></tr>
<tr class="separator:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a360c112cc3017a5152ebf6e84d2efa70">Parent</a> (void) const </td></tr>
<tr class="memdesc:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parent.  <a href="#a360c112cc3017a5152ebf6e84d2efa70">More...</a><br /></td></tr>
<tr class="separator:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#ae22db4d723ec2d50b3ba48f26a6a770c">TypeChilds</a> (void) const </td></tr>
<tr class="memdesc:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs of the same type.  <a href="#ae22db4d723ec2d50b3ba48f26a6a770c">More...</a><br /></td></tr>
<tr class="separator:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a344f81cd35805a9501098bf727ac1a10">Childs</a> (void) const </td></tr>
<tr class="memdesc:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs.  <a href="#a344f81cd35805a9501098bf727ac1a10">More...</a><br /></td></tr>
<tr class="separator:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#af001feba14fc053aa778e61080a0b4cf">Information</a> (const char *function, int line, const char *format,...) const </td></tr>
<tr class="memdesc:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted information.  <a href="#af001feba14fc053aa778e61080a0b4cf">More...</a><br /></td></tr>
<tr class="separator:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a168b18451b2ee6126e1e81d452005ff6">Warning</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted warning.  <a href="#a168b18451b2ee6126e1e81d452005ff6">More...</a><br /></td></tr>
<tr class="separator:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a3ca9694d29ec2b0491739879685df5ca">Error</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted error.  <a href="#a3ca9694d29ec2b0491739879685df5ca">More...</a><br /></td></tr>
<tr class="separator:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a36cdd7f556e78b1bddd1d1fe4264bb85">ErrorOccured</a> (bool recursive=true) const </td></tr>
<tr class="memdesc:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Has an errror occured?  <a href="#a36cdd7f556e78b1bddd1d1fe4264bb85">More...</a><br /></td></tr>
<tr class="separator:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a3df9057ae23eb34f1b1dae8e7a4a9efc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc">ProcessUpdate</a> (<a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *data)</td></tr>
<tr class="memdesc:a3df9057ae23eb34f1b1dae8e7a4a9efc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process the childs of type <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>, and log if needed.  <a href="#a3df9057ae23eb34f1b1dae8e7a4a9efc">More...</a><br /></td></tr>
<tr class="separator:a3df9057ae23eb34f1b1dae8e7a4a9efc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a120fdcc3d50f6f076084cb6943fdf412"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#a120fdcc3d50f6f076084cb6943fdf412">SetIsReady</a> (bool status)</td></tr>
<tr class="memdesc:a120fdcc3d50f6f076084cb6943fdf412"><td class="mdescLeft">&#160;</td><td class="mdescRight">set is ready  <a href="#a120fdcc3d50f6f076084cb6943fdf412">More...</a><br /></td></tr>
<tr class="separator:a120fdcc3d50f6f076084cb6943fdf412"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aead8f82fd3133168041c37cc471077d5"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_i_o_device.html#aead8f82fd3133168041c37cc471077d5">UpdateFrom</a> (const <a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *data)=0</td></tr>
<tr class="memdesc:aead8f82fd3133168041c37cc471077d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update using provided datas.  <a href="#aead8f82fd3133168041c37cc471077d5">More...</a><br /></td></tr>
<tr class="separator:aead8f82fd3133168041c37cc471077d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aed5fccda511f97487040fed29f4efc97"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>color_t</b> { <b>Auto</b> = 0, 
<b>Red</b> = 31, 
<b>Green</b> = 32, 
<b>Orange</b> = 33
 }</td></tr>
<tr class="separator:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract class for input/ouput system. </p>
<p>An input/output system is generally used to describe a sensor, an actuator or a filter. <br />
 These systems can be linked (for exemple a sensor with a filter), when an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> is created with a parent of type <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>. In this case, an update of the parent's data will call an update of the child's data (for exemple when a sensor gets new datas, a filter is automatically called). <br />
 Output of this object can also be sent to a shared memory using the OutputToShMem method; in order to use it with an external program. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9693b497752b466891eaafeb34bec4d3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">flair::core::IODevice::IODevice </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> of <a class="el" href="classflair_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. ">Object</a>'s type "IODevice" (see <a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53" title="Type. ">Object::ObjectType</a>). <br />
 If parent's <a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53" title="Type. ">Object::ObjectType</a> is also "IODevice", this <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> will be linked to its parent (see <a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc" title="Process the childs of type IODevice, and log if needed. ">ProcessUpdate()</a>).</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parent</td><td>parent </td></tr>
    <tr><td class="paramname">name</td><td>name </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a05246988b486def40926d8491e1bcc5f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual flair::core::IODevice::~IODevice </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="af7b42de6bb3893df860063228b55c229"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::IODevice::AddDeviceToLog </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_i_o_device.html">IODevice</a> *&#160;</td>
          <td class="paramname"><em>device</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Add an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> to the logs. </p>
<p>The <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> will be automatically logged among this <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> logs, if logging is enabled (see SetDataToLog(), <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a1cbc5e8296c0f36551210e13251516ae" title="Start logging. ">FrameworkManager::StartLog</a> and <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a9f2750ce913b492206761340c666bbb6" title="Add log element. ">FrameworkManager::AddDeviceToLog</a>). <br />
Logging happens when <a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc" title="Process the childs of type IODevice, and log if needed. ">ProcessUpdate()</a> is called. <br />
Note that when an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> is just added for logs (ie. no parent/child link between the two <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>), <a class="el" href="classflair_1_1core_1_1_i_o_device.html#aead8f82fd3133168041c37cc471077d5" title="Update using provided datas. ">UpdateFrom()</a> is not automatically called.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">device</td><td><a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> to log </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2e0b7af75abdbf39843d8bf2e45f08b9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::IODevice::AddDataToLog </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Add an <a class="el" href="classflair_1_1core_1_1io__data.html" title="Abstract class for data types. ">io_data</a> to the log. </p>
<p>The <a class="el" href="classflair_1_1core_1_1io__data.html" title="Abstract class for data types. ">io_data</a> will be automatically logged if enabled (see <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a1cbc5e8296c0f36551210e13251516ae" title="Start logging. ">FrameworkManager::StartLog</a> and <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a9f2750ce913b492206761340c666bbb6" title="Add log element. ">FrameworkManager::AddDeviceToLog</a>), during call to <a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc" title="Process the childs of type IODevice, and log if needed. ">ProcessUpdate()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>data to log </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a12d811c6926fb86da6b47f889109da66"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::IODevice::OutputToShMem </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>enabled</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send the output to a shared memory. </p>
<p>Use this method to output log datas to a shared memory. This can be usefull to get datas from an external progam. <br />
Output happens when <a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc" title="Process the childs of type IODevice, and log if needed. ">ProcessUpdate()</a> is called. <br />
The name and the structure of the shared memory will be displayed when this method is called with true as argument. <br />
By default it is not enabled.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">enabled</td><td>true to enable the output, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aee7828ae2eece2bace8e476dacc2bc12"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool flair::core::IODevice::IsReady </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>is device ready </p>
<p>Use it check if a device is ready or not. See also setIsReady.</p>
<dl class="section return"><dt>Returns</dt><dd>true if device is ready </dd></dl>

</div>
</div>
<a class="anchor" id="a3df9057ae23eb34f1b1dae8e7a4a9efc"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::IODevice::ProcessUpdate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Process the childs of type <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>, and log if needed. </p>
<p>This method must be called after computing datas; generally at the end of the reimplemented UpdateFrom or after acquiring datas in case of a sensor. <br />
It will call UpdateFrom methods of each child of type <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>, and log all datas (this <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> and its childs) if logging is enabled (see SetDataToLog(), <a class="el" href="classflair_1_1core_1_1_i_o_device.html#af7b42de6bb3893df860063228b55c229" title="Add an IODevice to the logs. ">AddDeviceToLog()</a>, <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a1cbc5e8296c0f36551210e13251516ae" title="Start logging. ">FrameworkManager::StartLog</a> and <a class="el" href="classflair_1_1core_1_1_framework_manager.html#a9f2750ce913b492206761340c666bbb6" title="Add log element. ">FrameworkManager::AddDeviceToLog</a>). <br />
If a thread is waiting on this <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> (see <a class="el" href="classflair_1_1core_1_1_thread.html#a2b5b5f3cf400729419bd864b654af252" title="Wait update of an IODevice. ">Thread::WaitUpdate</a>), it will be resumed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>data to process </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a120fdcc3d50f6f076084cb6943fdf412"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::IODevice::SetIsReady </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>status</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>set is ready </p>
<p>Sets if the device is ready or not. By default the <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> is not ready.<br />
See also isReady.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">status</td><td>status </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aead8f82fd3133168041c37cc471077d5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void flair::core::IODevice::UpdateFrom </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1io__data.html">io_data</a> *&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Update using provided datas. </p>
<p>This method is automatically called by <a class="el" href="classflair_1_1core_1_1_i_o_device.html#a3df9057ae23eb34f1b1dae8e7a4a9efc" title="Process the childs of type IODevice, and log if needed. ">ProcessUpdate()</a> of the <a class="el" href="classflair_1_1core_1_1_object.html#a360c112cc3017a5152ebf6e84d2efa70" title="Parent. ">Object::Parent</a>'s if its <a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53" title="Type. ">Object::ObjectType</a> is "IODevice". <br />
 This method must be reimplemented, in order to process the data from the parent.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>data from the parent to process </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classflair_1_1filter_1_1_butterworth_low_pass.html#a0f33384da8b2278f8b3f6a8235134edc">flair::filter::ButterworthLowPass</a>, and <a class="el" href="classflair_1_1sensor_1_1_target_controller.html#a1e883144c9ebf38961b7bce349fd8da3">flair::sensor::TargetController</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceflair.html">flair</a></li><li class="navelem"><a class="el" href="namespaceflair_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classflair_1_1core_1_1_i_o_device.html">IODevice</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
